Index: uspace/lib/display/include/disp_srv.h
===================================================================
--- uspace/lib/display/include/disp_srv.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
+++ uspace/lib/display/include/disp_srv.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
@@ -41,4 +41,5 @@
 #include "display/wndparams.h"
 #include "types/display/event.h"
+#include "types/display/wndresize.h"
 
 typedef struct display_ops display_ops_t;
@@ -55,4 +56,6 @@
 	errno_t (*window_destroy)(void *, sysarg_t);
 	errno_t (*window_move_req)(void *, sysarg_t, gfx_coord2_t *);
+	errno_t (*window_resize_req)(void *, sysarg_t, display_wnd_rsztype_t,
+	    gfx_coord2_t *);
 	errno_t (*window_resize)(void *, sysarg_t, gfx_coord2_t *, gfx_rect_t *);
 	errno_t (*get_event)(void *, sysarg_t *, display_wnd_ev_t *);
Index: uspace/lib/display/include/display.h
===================================================================
--- uspace/lib/display/include/display.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
+++ uspace/lib/display/include/display.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
@@ -41,4 +41,5 @@
 #include <stdbool.h>
 #include "display/wndparams.h"
+#include "display/wndresize.h"
 #include "types/display.h"
 
@@ -50,4 +51,6 @@
 extern errno_t display_window_get_gc(display_window_t *, gfx_context_t **);
 extern errno_t display_window_move_req(display_window_t *, gfx_coord2_t *);
+extern errno_t display_window_resize_req(display_window_t *,
+    display_wnd_rsztype_t, gfx_coord2_t *);
 extern errno_t display_window_resize(display_window_t *,
     gfx_coord2_t *, gfx_rect_t *);
Index: uspace/lib/display/include/display/wndresize.h
===================================================================
--- uspace/lib/display/include/display/wndresize.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
+++ uspace/lib/display/include/display/wndresize.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdisplay
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPLAY_DISPLAY_WNDRESIZE_H_
+#define _LIBDISPLAY_DISPLAY_WNDRESIZE_H_
+
+#include "../types/display/wndresize.h"
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/display/include/ipc/display.h
===================================================================
--- uspace/lib/display/include/ipc/display.h	(revision a2e104e0deacc5a9fdacf4d8e3824726c77c47a5)
+++ uspace/lib/display/include/ipc/display.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
@@ -44,4 +44,5 @@
 	DISPLAY_WINDOW_MOVE_REQ,
 	DISPLAY_WINDOW_RESIZE,
+	DISPLAY_WINDOW_RESIZE_REQ,
 	DISPLAY_GET_EVENT
 } display_request_t;
Index: uspace/lib/display/include/types/display/wndresize.h
===================================================================
--- uspace/lib/display/include/types/display/wndresize.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
+++ uspace/lib/display/include/types/display/wndresize.h	(revision 1e4a937d249f5477ae9be53bbb34c94e8942f19d)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdisplay
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPLAY_TYPES_DISPLAY_WNDRESIZE_H_
+#define _LIBDISPLAY_TYPES_DISPLAY_WNDRESIZE_H_
+
+/** Window resize type */
+typedef enum {
+	display_wr_top = 0x1,
+	display_wr_left = 0x2,
+	display_wr_bottom = 0x4,
+	display_wr_right = 0x8,
+
+	display_wr_top_left = display_wr_top | display_wr_left,
+	display_wr_bottom_left = display_wr_bottom | display_wr_left,
+	display_wr_bottom_right = display_wr_bottom | display_wr_right,
+	display_wr_top_right = display_wr_top | display_wr_right
+} display_wnd_rsztype_t;
+
+#endif
+
+/** @}
+ */
